#include <stdio.h>
#include <math.h>

#define maxGULA 25+1
#define INF 1e10
#define EPS 1e-15


typedef double real;
typedef real VECTOR[2];
typedef enum {FALSE,TRUE} BOOL;

typedef struct
{
  VECTOR A;
  real r; 
} GULA;

int n;
int sc = 0;
GULA G[maxGULA];
VECTOR L,v;


real min(real x, real y)
{
  return x < y ? x : y;
}


real max(real x, real y)
{
  return x > y ? x : y;
}


BOOL mensir0(real x)
{
  return x < EPS ? TRUE : FALSE;
}

BOOL zrazka(VECTOR &L, VECTOR &v, GULA &G, real &kg)
                                      {
  VECTOR C;
  real a,b,c,D;
  real k1,k2,k;
  
  C[0] = L[0] - G.A[0];
  C[1] = L[1] - G.A[1];
  
  a = v[0] * v[0]  +  v[1] * v[1];
  b = 2 * v[0] * C[0]  +  2 * v[1] * C[1];
  c = C[0] * C[0]  +  C[1] * C[1]  -  G.r * G.r;
  
  D = b*b - 4*a*c;
 
//printf(" \n--- DISK: %lf", D);

  if (D<0) return FALSE;
  
  D = sqrt(D); 
  k1 = (-b + D) / (2*a);
  k2 = (-b - D) / (2*a);
  
//printf("\n ---> !korene : %lf %lf",k1,k2);
  k = min (k1,k2);

  if (mensir0(k))  k = max (k1,k2);
  if (mensir0(k))  return FALSE;
 
//printf("\n -------> k: %lf", k);
  kg = k;
  return TRUE;
}


BOOL najdiGulu(VECTOR &L, VECTOR &v,  int &gi, real &kmin)
{
  int i;
  real k;
  
  kmin = INF;
  for (i = 0;  i < n; i++)
  {
//printf("\n ---> pocitam gulu: %d",i);
    if (zrazka(L,v,G[i],k))
     if (k < kmin)
     {
       kmin = k;
       gi = i;
//printf("\n -----> !zrazka s gulou: %d %lf",gi,kmin);
     }  
  }

  if (kmin == INF) return FALSE; else return TRUE;
}

BOOL novaGula(VECTOR &L, VECTOR &v,  int &gi)
{
  real k;
  VECTOR X,gn,vv,vg;
  real gg,skalar;
  
  
  if (najdiGulu(L,v, gi,k))
  {
    X[0] = L[0] + k * v[0];
    X[1] = L[1] + k * v[1];  


/*
printf("\n ----> gula x,y: %lf   %lf", G[gi].A[0],G[gi].A[1] );
printf("\n ----> lucV x,y: %lf   %lf", v[0],v[1] );

printf("\n ----> nasiel gulu: %d %lf", gi,k);
printf("\n ----> zrazka: %lf %lf", X[0],X[1]);
*/
  }
  else return FALSE;
  
  gn[0] = G[gi].A[0] - X[0];
  gn[1] = G[gi].A[1] - X[1];
  gg = sqrt ( gn[0] * gn[0]  + gn[1] * gn[1] );
  gn[0] = gn[0] / gg;
  gn[1] = gn[1] / gg;
   
  skalar = gn[0] * v[0]  + gn[1] * v[1];
  vg[0] = skalar * gn[0];
  vg[1] = skalar * gn[1];
  
  vv[0] = v[0] - vg[0];
  vv[1] = v[1] - vg[1];
  
  v[0] = vv[0] - vg[0];
  v[1] = vv[1] - vg[1];
  
  L[0] = X[0];
  L[1] = X[1];
  return TRUE;

//  printf ("\n\n   --- > luc: Lx,y, vx,y %lf %lf    %lf %lf", L[0],L[1], v[0],v[1]);
}

  
BOOL posl()
{
  int i;
  int gx,gy,gr;
  int lx,ly,vx,vy;
  
  scanf("%d",&n);
  if (n==0) return TRUE;
  for (i = 0; i < n; i++)
  {
    scanf ("%d %d %d", &gx, &gy, &gr);
    G[i].A[0] = (real)gx;
    G[i].A[1] = (real)gy;
    G[i].r = (real)gr;
  }
  scanf ("%d %d %d %d", &lx, &ly, &vx, &vy);
  L[0] = (real)lx;
  L[1] = (real)ly;
  v[0] = (real)vx;
  v[1] = (real)vy;
  
  return FALSE;
}


void rob()
{
  int gi = -1;
  int i = 1;
  
  if (sc++) printf("\n");
  printf("Scene %d\n", sc);
  
  while ( (i<=10) && (novaGula(L,v,gi)) )
  {
    printf("%d ", gi+1);
    i++;
  }  
  
  if (i>10) printf("...\n");
   else printf("inf\n");

//  printf ("\n narazil na gulu: %d", gi);
//  printf ("\n\n   ------------- > nove Lx,y, vx,y %lf %lf    %lf %lf", L[0],L[1], v[0],v[1]);
}

main()
{
  while (!posl())  rob();
  
}